﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace AsyncAwaitExample
{
    class Program
    {
        static async Task Main(string[] args)
        {
            //MyTask();

            var ts = MyTaskAsync();
        }

        /// <summary>
        /// Simulates an asynchrounous task.
        /// </summary>
        /// <returns>A static string.</returns>
        static async Task MyTaskAsync()
        {
            var s1 = StepOneAsync(1);
            var s2 = StepTwoAsync();
            var s3 = StepThreeAsync();

            await s1;
            await s2;
            await s3;

            System.Console.WriteLine("DONE.");
        }

        /// <summary>
        /// This is an example.
        /// </summary>
        /// <param name="test">Test Parameter</param>
        /// <returns>Nothing.</returns>
        static async Task<string> StepOneAsync(int test)
        {
            await Task.Run(() => { });
            System.Console.WriteLine("Start Step One.");
            Thread.Sleep(4000);
            System.Console.WriteLine("S1 Complete");
            return "Hello World.";
        }

        static async Task StepTwoAsync()
        {
            await Task.Run(() => { });
            System.Console.WriteLine("Start Step Two.");
            Thread.Sleep(1000);
            System.Console.WriteLine("S2 Complete");
        }

        static async Task StepThreeAsync()
        {
            await Task.Run(() => { });
            System.Console.WriteLine("Start Step Three.");
            Thread.Sleep(4000);
            System.Console.WriteLine("S3 Complete");
        }

        static void MyTask()
        {
            System.Console.WriteLine("Start Step One.");
            Thread.Sleep(2000);
            System.Console.WriteLine("S1 Complete");


            System.Console.WriteLine("Start Step Two.");
            Thread.Sleep(2000);
            System.Console.WriteLine("S2 Complete");


            System.Console.WriteLine("Start Step Three.");
            Thread.Sleep(2000);
            System.Console.WriteLine("S3 Complete");


            System.Console.WriteLine("Start Step Four.");
            Thread.Sleep(2000);
            System.Console.WriteLine("S4 Complete");
        }
    }
}
